From: Alfred Neumayer <dev.beidl@gmail.com>
Date: Thu, 7 Dec 2023 16:44:33 +0700
Subject: adb: re-implements android-base/properties.h in terms of libhybris

[ratchanan@ubports.com:
- split original patch into manageable chunks
- forward-port to 14.0.0+r45
]
---
 adb.cpp                                     |  2 +-
 adb_trace.cpp                               |  2 +-
 daemon/adb_wifi.cpp                         |  2 +-
 daemon/logging.cpp                          |  2 +-
 daemon/main.cpp                             |  2 +-
 daemon/mdns.cpp                             |  2 +-
 daemon/property_monitor_test.cpp            |  2 +-
 daemon/restart_service.cpp                  |  2 +-
 daemon/restart_service_test.cpp             |  2 +-
 daemon/services.cpp                         |  2 +-
 daemon/shell_service.cpp                    |  2 +-
 daemon/transport_local.cpp                  |  2 +-
 daemon/usb.cpp                              |  2 +-
 daemon/usb_ffs.cpp                          |  2 +-
 daemon/watchdog.cpp                         |  2 +-
 fake_base.h                                 | 32 +++++++++++++++++++++++++++++
 libs/adbconnection/adbconnection_client.cpp |  2 +-
 sockets.cpp                                 |  2 +-
 18 files changed, 49 insertions(+), 17 deletions(-)
 create mode 100644 fake_base.h

diff --git a/adb.cpp b/adb.cpp
index e375c72..0702ea1 100644
--- a/adb.cpp
+++ b/adb.cpp
@@ -63,7 +63,7 @@
 #if !ADB_HOST
 #include <sys/capability.h>
 #include <sys/mount.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 using namespace std::chrono_literals;
 
 #include "daemon/logging.h"
diff --git a/adb_trace.cpp b/adb_trace.cpp
index 210241c..ee3eecc 100644
--- a/adb_trace.cpp
+++ b/adb_trace.cpp
@@ -27,7 +27,7 @@
 #include "adb.h"
 
 #if !ADB_HOST
-#include <android-base/properties.h>
+#include "fake_base.h"
 #endif
 
 #if !ADB_HOST
diff --git a/daemon/adb_wifi.cpp b/daemon/adb_wifi.cpp
index 2de219d..0817a50 100644
--- a/daemon/adb_wifi.cpp
+++ b/daemon/adb_wifi.cpp
@@ -24,7 +24,7 @@
 #include <optional>
 
 #include <adbd_auth.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 
 #include "adb.h"
 #include "daemon/mdns.h"
diff --git a/daemon/logging.cpp b/daemon/logging.cpp
index 203c6c7..d40e371 100644
--- a/daemon/logging.cpp
+++ b/daemon/logging.cpp
@@ -21,7 +21,7 @@
 #include <string_view>
 
 #include <android-base/no_destructor.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/strings.h>
 #include <android-base/thread_annotations.h>
 
diff --git a/daemon/main.cpp b/daemon/main.cpp
index 677e853..c41cb6f 100644
--- a/daemon/main.cpp
+++ b/daemon/main.cpp
@@ -36,7 +36,7 @@
 
 #include <android-base/logging.h>
 #include <android-base/macros.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/stringprintf.h>
 #include <android-base/strings.h>
 
diff --git a/daemon/mdns.cpp b/daemon/mdns.cpp
index c1e766e..a78a0c8 100644
--- a/daemon/mdns.cpp
+++ b/daemon/mdns.cpp
@@ -28,7 +28,7 @@
 #include <thread>
 
 #include <android-base/logging.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 
 using namespace std::chrono_literals;
 
diff --git a/daemon/property_monitor_test.cpp b/daemon/property_monitor_test.cpp
index 29c441e..c57a9b3 100644
--- a/daemon/property_monitor_test.cpp
+++ b/daemon/property_monitor_test.cpp
@@ -28,7 +28,7 @@
 #include <vector>
 
 #include <android-base/logging.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/thread_annotations.h>
 #include <gtest/gtest.h>
 
diff --git a/daemon/restart_service.cpp b/daemon/restart_service.cpp
index 16d2627..6f9a6fd 100644
--- a/daemon/restart_service.cpp
+++ b/daemon/restart_service.cpp
@@ -21,7 +21,7 @@
 #include <unistd.h>
 
 #include <android-base/logging.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/stringprintf.h>
 #include <log/log_properties.h>
 
diff --git a/daemon/restart_service_test.cpp b/daemon/restart_service_test.cpp
index d2ae67c..831aed0 100644
--- a/daemon/restart_service_test.cpp
+++ b/daemon/restart_service_test.cpp
@@ -19,7 +19,7 @@
 #include <time.h>
 #include <string>
 
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/stringprintf.h>
 #include <android-base/strings.h>
 #include <gtest/gtest.h>
diff --git a/daemon/services.cpp b/daemon/services.cpp
index 07fbe32..84d52cd 100644
--- a/daemon/services.cpp
+++ b/daemon/services.cpp
@@ -35,7 +35,7 @@
 #include <android-base/file.h>
 #include <android-base/parseint.h>
 #include <android-base/parsenetaddress.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/stringprintf.h>
 #include <android-base/strings.h>
 #include <android-base/unique_fd.h>
diff --git a/daemon/shell_service.cpp b/daemon/shell_service.cpp
index dbca4ad..143bbab 100644
--- a/daemon/shell_service.cpp
+++ b/daemon/shell_service.cpp
@@ -94,7 +94,7 @@
 #include <vector>
 
 #include <android-base/logging.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/stringprintf.h>
 #include <private/android_logger.h>
 
diff --git a/daemon/transport_local.cpp b/daemon/transport_local.cpp
index 1b459e4..148d3e2 100644
--- a/daemon/transport_local.cpp
+++ b/daemon/transport_local.cpp
@@ -39,7 +39,7 @@
 #include <cutils/sockets.h>
 
 #if !ADB_HOST
-#include <android-base/properties.h>
+#include "fake_base.h"
 #endif
 
 #include "adb.h"
diff --git a/daemon/usb.cpp b/daemon/usb.cpp
index f9e085f..4b2a595 100644
--- a/daemon/usb.cpp
+++ b/daemon/usb.cpp
@@ -43,7 +43,7 @@
 #include <android-base/logging.h>
 #include <android-base/macros.h>
 #include <android-base/parsebool.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/thread_annotations.h>
 
 #include "adb_unique_fd.h"
diff --git a/daemon/usb_ffs.cpp b/daemon/usb_ffs.cpp
index e538ca8..69394cb 100644
--- a/daemon/usb_ffs.cpp
+++ b/daemon/usb_ffs.cpp
@@ -24,7 +24,7 @@
 #include <linux/usb/functionfs.h>
 
 #include <android-base/logging.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/unique_fd.h>
 
 #include "adb.h"
diff --git a/daemon/watchdog.cpp b/daemon/watchdog.cpp
index 741c5b1..f3f5cb0 100644
--- a/daemon/watchdog.cpp
+++ b/daemon/watchdog.cpp
@@ -25,7 +25,7 @@
 #include <android-base/logging.h>
 #include <android-base/parsebool.h>
 #include <android-base/parseint.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/thread_annotations.h>
 
 #include "property_monitor.h"
diff --git a/fake_base.h b/fake_base.h
new file mode 100644
index 0000000..7170906
--- /dev/null
+++ b/fake_base.h
@@ -0,0 +1,32 @@
+#ifndef ANDROID_FAKE_BASE_H
+#define ANDROID_FAKE_BASE_H
+
+#include <hybris/properties/properties.h>
+#include <string>
+#include <chrono>
+
+// Fake android properties since the system ones are Bionic-only
+namespace android {
+namespace base {
+
+static std::string GetProperty(const std::string& property, const std::string& defaultValue) {
+    std::string val;
+    val.reserve(PROP_VALUE_MAX);
+    property_get(property.c_str(), (char*)val.c_str(), defaultValue.c_str());
+    return val;
+}
+
+static bool GetBoolProperty(const std::string& property, bool defaultValue) {
+    std::string ret = GetProperty(property, defaultValue ? "true" : "false");
+    return (ret == "true" || ret == "1");
+}
+
+static bool SetProperty(const std::string& property, std::string value) {
+    return (property_set(property.c_str(), value.c_str()) == 0);
+}
+
+}
+}
+
+
+#endif
diff --git a/libs/adbconnection/adbconnection_client.cpp b/libs/adbconnection/adbconnection_client.cpp
index bea0381..2f8e5e3 100644
--- a/libs/adbconnection/adbconnection_client.cpp
+++ b/libs/adbconnection/adbconnection_client.cpp
@@ -27,7 +27,7 @@
 
 #include <android-base/cmsg.h>
 #include <android-base/logging.h>
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <android-base/unique_fd.h>
 
 #include "adbconnection/process_info.h"
diff --git a/sockets.cpp b/sockets.cpp
index 630a2eb..8a9a26c 100644
--- a/sockets.cpp
+++ b/sockets.cpp
@@ -35,7 +35,7 @@
 #include <android-base/strings.h>
 
 #if !ADB_HOST
-#include <android-base/properties.h>
+#include "fake_base.h"
 #include <log/log_properties.h>
 #endif
 
